Subject: Re: bug#47388: 27.1; eldoc-documentation-function is ignore in updated eldoc

From: Stefan Monnier <[email-masked]>
Date: Sun, 28 Mar 2021 15:36:05 -0400

>> > Note that that all this mess has to do with the silliness that is having
>> > eldoc.el be preloaded just becuase elisp-mode.el.  How would we go about
>> > fixing that?
>> We could stop preloading `elisp-mode`.
> Even better, but can you say why it's even preloaded at all?
> Certainly not somebody's whim, right?

The code for `emacs-lisp-mode` used to be in `lisp-mode.el` which also
contains various functions useful in all modes, so it's been preloaded
since before I started using Emacs.
When I moved (some of) the code to `progmodes/elisp-mode.el` I just
preserved that pre-existing situation.

I don't know for a fact, but based on my vague memory of what's in
`elisp-mode.el` I don't think there's a strong technical reason to
preload it.

IOW it's only preloaded because we expect it would be loaded sooner or
later anyway in many/most Emacs sessions.  I don't know if it's indeed
the case (tho it is clearly the case for *my* sessions), so you could
try to float the idea on `emacs-devel`.

        Stefan